<template>
    <!-- REMOVE THIS DIV AND THE ANIMATION WILL BREAK -->
    <div :style="{'min-height':'100%'}">
        <el-menu :collapse="isCollapsed"
            :background-color="primaryColor"
            :text-color="primaryText"
            :active-text-color="activeText"
            class="sidebar-vertical"
            :router="true"
            @mouseover="menuCollapseOpen"
            @mouseleave="menuCollapseClose">
            <el-menu-item>
                <img :src="logo" style="min-width:1em;min-height:1em;width:100%;height:100%;">
            </el-menu-item>
            <template v-for="(sidebarNode, index) in sidebarNodeList">
                <el-menu-item
                    v-bind:key="sidebarNode.name"
                    :index="index.toString()"
                    :route="sidebarNode.route">
                    <i :class="sidebarNode.icon"
                        :style="primaryTextStyle"></i>
                    <span slot="title">{{$t(sidebarNode.name)}}</span>
                </el-menu-item>
            </template>
        </el-menu>
    </div>
</template>
<style scoped>
.sidebar-vertical:not(.el-menu--collapse) {
    width:14em;
}
.sidebar-vertical.el-menu--collapse {
    width:4em;
}
.sidebar-vertical {
    display:flex;
    flex-direction: column;
    height: 100%
}
.sidebar-vertical__body {
    flex-grow: 0.97;
}
</style>
<script>
"use strict";

import Logo from "./../../logo.svg";
import SidebarNodeList from "./sidebar";

export default {
    name: "Sidebar",
    data() {
        return {
            sidebarNodeList: SidebarNodeList,
            logo: Logo
        };
    },
    computed: {
        isCollapsed() {
            return this.$store.state.ui.sidebar.isCollapsed;
        },
        rotation() {
            return {
                transform: `rotate(${this.isCollapse? 90 : 0}deg)`
            };
        },
        primaryColor: () => process.env.PRIMARY_COLOR,
        primaryText: () => process.env.PRIMARY_TEXT,
        activeColor: () => process.env.ACTIVE_COLOR,
        activeText: () => process.env.ACTIVE_TEXT,
        primaryTextStyle() {
            return `color:${this.primaryText}`;
        }
    },
    methods: {
        menuCollapseClose() {
            this.isCollapse = true;
        },
        menuCollapseOpen() {
            this.isCollapse = false;
        },
        menuCollapseTrigger() {
            this.$store.state.commit("sidebarCollapse");
        }
    }
};
</script>
